summaryrefslogtreecommitdiffstats
path: root/qcad
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2008-03-06 15:06:54 +0000
committer Eric Hameleers <alien@slackware.com>2008-03-06 15:06:54 +0000
commit9ad2b6dcb948269165736b500357b503b031d77c (patch)
tree17e54fe9f8a55cfbab52fae3607250c29b70877b /qcad
parent1fc60c16d3760c6be52f1577f14b2a5386a38b43 (diff)
downloadasb-9ad2b6dcb948269165736b500357b503b031d77c.tar.gz
asb-9ad2b6dcb948269165736b500357b503b031d77c.tar.xz
Initial revision
Diffstat (limited to 'qcad')
-rwxr-xr-xqcad/build/qcad.SlackBuild253
1 files changed, 253 insertions, 0 deletions
diff --git a/qcad/build/qcad.SlackBuild b/qcad/build/qcad.SlackBuild
new file mode 100755
index 00000000..1ebb20c7
--- /dev/null
+++ b/qcad/build/qcad.SlackBuild
@@ -0,0 +1,253 @@
+#!/bin/sh
+# $Id$
+# Copyright (c) 2008 Eric Hameleers <alien@slackware.com>
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: qcad
+# Descr: a simple 2D CAD program
+# URL: http://www.qcad.org/qcad.html
+# Needs:
+# Changelog:
+# 2.0.5.0-1: 06/Mar/2008 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh qcad.SlackBuild --cleanup' to build a Slackware package.
+# The package (.tgz) plus descriptive .txt file are created in /tmp .
+# Install using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+# Set initial variables:
+
+PRGNAM=qcad
+VERSION=${VERSION:-2.0.5.0}
+MANVER=${MANVER:-2.1.0.0}
+ARCH=${ARCH:-i486}
+BUILD=${BUILD:-1}
+
+DOCS="qcad/README qcad/data"
+
+# Where do we look for sources?
+CWD=$(pwd)
+SRCDIR=$(dirname $0)
+[ "${SRCDIR:0:1}" == "." ] && SRCDIR=${CWD}/${SRCDIR}
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE[0]="$SRCDIR/${PRGNAM}-${VERSION}-1-community.src.tar.gz"
+SRCURL[0]="ftp://ribbonsoft.com/archives/${PRGNAM}/${PRGNAM}-${VERSION}-1-community.src.tar.gz"
+
+SOURCE[1]="${PRGNAM}-manual-en-${MANVER}-1.html.zip"
+SRCURL[1]="ftp://ribbonsoft.com/archives/${PRGNAM}/${PRGNAM}-manual-en-${MANVER}-1.html.zip"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Slackware 11 and up need other option (gcc > 3.3.x)
+if [ $(gcc -dumpversion | tr -d '.' |cut -c 1-2) -gt 33 ]; then
+ MOPT=tune
+else
+ MOPT=cpu
+fi
+
+case "$ARCH" in
+ i386) SLKCFLAGS="-O2 -march=i386 -m${MOPT}=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ i486) SLKCFLAGS="-O2 -march=i486 -m${MOPT}=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ s390) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ powerpc) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ athlon-xp) SLKCFLAGS="-march=athlon-xp -O3 -pipe -fomit-frame-pointer"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+esac
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+if [ "$P1" != "--oldbuild" ]; then
+ # Use the "--oldbuild" parameter to keep old build files and continue;
+ # By default we remove the remnants of previous build and continue.
+ rm -rf $TMP/tmp-$PRGNAM/*
+fi
+
+# Source file availability:
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if ! [ -f ${SOURCE[$i]} ]; then
+ if ! [ "x${SRCURL[$i]}" == "x" ]; then
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
+ echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
+ echo "Will download file to $(dirname $SOURCE[$i])"
+ wget -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
+ echo "Downloading '$(basename ${SOURCE[$i]})' failed.. aborting the build."
+ mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE[$i]})' not available.. aborting the build."
+ exit 1
+ fi
+ fi
+done
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if $(file ${SOURCE[$i]} | grep -q ": bzip2"); then
+ tar -xjvf ${SOURCE[$i]}
+ elif $(file ${SOURCE[$i]} | grep -q ": gzip"); then
+ tar -xzvf ${SOURCE[$i]}
+ fi
+done
+mv ${PRGNAM}-${VERSION}-1-community.src ${PRGNAM}-${VERSION}
+cd ${PRGNAM}-${VERSION}
+chown -R root:root .
+chmod -R u+w,go+r-w,a-s .
+
+echo Building ...
+export LDFLAGS="$SLKLDFLAGS"
+export CXXFLAGS="$SLKCFLAGS"
+export CFLAGS="$SLKCFLAGS"
+export QTDIR=/usr/lib/qt3
+(
+ cd scripts
+ ./build_qcad.sh
+)
+find -name *.ts -exec lrelease {} \;
+find -name *.qm -exec cp {} qcad/qm \;
+
+# Install all the needed stuff to the package dir
+mkdir -p $PKG/usr/share/qcad/{library,doc}
+
+cp -fr qcad-manual-en-${MANVER}-1.html/* $PKG/usr/share/qcad/doc/
+
+cd qcad
+cp -fr fonts $PKG/usr/share/qcad/
+cp -fr patterns $PKG/usr/share/qcad/
+cp -fr qm $PKG/usr/share/qcad/
+
+mkdir -p $PKG/usr/bin
+cp -f qcad $PKG/usr/bin/
+
+# Create a .desktop file with a suitable icon:
+mkdir -p $PKG/usr/share/pixmaps
+cp -f src/xpm/qcad.xpm $PKG/usr/share/pixmaps
+mkdir -p $PKG/usr/share/applications
+cat <<-EOT > $PKG/usr/share/applications/cqad.desktop
+ [Desktop Entry]
+ Name=QCad
+ GenericName=2D CAD drawing
+ Comment=A simple 2D CAD program
+ Exec=qcad
+ Icon=qcad.xpm
+ Terminal=false
+ Type=Application
+ MimeType=image/vnd.dxf
+ Encoding=UTF-8
+ StartupNotify=true
+ StartupWMClass=qcad
+ EOT
+
+# Post-install script:
+mkdir -p $PKG/install
+cat <<-EOT > $PKG/install/doinst.sh
+ if [ -x usr/bin/update-desktop-database ]; then
+ chroot . /usr/bin/update-desktop-database /usr/share/applications 1>/dev/null 2>&1
+ fi
+ EOT
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+ln -s ../../share/qcad/doc html
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Strip binaries:
+cd $PKG
+find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+cd -
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+if [ -f $SRCDIR/doinst.sh ]; then
+ cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
+fi
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
+
+# Clean up the extra stuff:
+if [ "$P1" = "--cleanup" ]; then
+ rm -rf $TMP/tmp-$PRGNAM
+ rm -rf $PKG
+fi